﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx;
using Styx.Helpers;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System.Text;
using System.IO;
using System.Drawing;
using Styx.Common;
using System.Diagnostics;
using System.IO;
using System.Windows;
using System.ComponentModel;
using Styx.Plugins;

namespace ProfileBuilder
{
    class ProfileBuilder : HBPlugin
    {
        public override string Author { get { return "Ama"; } }
        public override Version Version { get { return new Version(1, 0, 0); } }
        public override string Name { get { return "ProfileBuilder"; } }
        public override string ButtonText { get { return "Please Work."; } }
        public override bool WantButton { get { return true; } }
        public Window DisplayWindow { get { return null; } }

        public static bool recording = false;
        public static string ProfileName = "myProfile";
        public static int interval = 3;
        public static int pointSeparation = 20;
        public static int startLevel = 1;
        public static int endLevel = 101;
        public static int currentLevel = 1;
        public static Stopwatch sw = new Stopwatch();
        public static List<GrindPoint> Merchants = new List<GrindPoint>();
        public static BindingList<GrindPoint> HotSpots = new BindingList<GrindPoint>();
        protected static LocalPlayer Me { get { return StyxWoW.Me; } }
        public static PBForm frm;
        public static string outputPath = Path.Combine(Directory.GetCurrentDirectory(), string.Format(@"Profiles\" + ProfileName + ".xml"));

        public static string SellGrey;
        public static string SellWhite;
        public static string SellGreen;
        public static string SellBlue;
        public static string SellPurple;

        public bool Equals(HBPlugin other)
        {
            return other.Name == Name;
        }

        public override void Initialize()
        {
            if(!sw.IsRunning)
                sw.Start();
        }

        public override void Pulse()
        {
            if (recording && sw.IsRunning && sw.Elapsed.TotalSeconds >= interval)
            {
                sw.Stop();
                sw.Reset();
                sw.Start();
                addHotSpots();
            }
        }

        public override void OnButtonPress()
        {
            frm = new PBForm();
            frm.Show();
        }

        public override void Dispose()
        {
            frm.Dispose();
            frm = null;
        }

        public void OnShutdown()
        {
            if (frm != null)
            {
                frm.Close();
                frm = null;
            }
        }

        public static void setSellStatus()
        {
            if (frm.SellGrey.Checked)
                SellGrey = "<SellGrey>True</SellGrey>";
            else
                SellGrey = "<SellGrey>False</SellGrey>";

            if (frm.SellWhite.Checked)
                SellWhite = "<SellWhite>True</SellWhite>";
            else
                SellWhite = "<SellWhite>False</SellWhite>";

            if (frm.SellGreen.Checked)
                SellGreen = "<SellGreen>True</SellGreen>";
            else
                SellGreen = "<SellGreen>False</SellGreen>";

            if (frm.SellBlue.Checked)
                SellBlue = "<SellBlue>True</SellBlue>";
            else
                SellBlue = "<SellBlue>False</SellBlue>";

            if (frm.SellPurple.Checked)
                SellPurple = "<SellPurple>True</SellPurple>";
            else
                SellPurple = "<SellPurple>False</SellPurple>";
        }

        public void addHotSpots()
        {
            GrindPoint gp;
            foreach(WoWUnit c in ObjectManager.GetObjectsOfType<WoWUnit>(true, true)){
                gp = new GrindPoint(c);
                if (c.IsVendor && c.IsRepairMerchant && !c.IsHostile && (GoodPoint(gp, Merchants)))
                {
                    Merchants.Add(gp);
                    Logging.Write("ProfileBuilder Added: " + gp.MobName);
                }

                if (c.IsHostile && c.Attackable && !c.IsPlayer && !c.IsNeutral && (int)c.Level >= startLevel && (int)c.Level <= endLevel && (GoodPoint(gp, HotSpots)))
                { 
                    HotSpots.Add(gp);
                    Logging.Write("ProfileBuilder Added: " + gp.MobName);
                }
            }
        }

        public bool GoodPoint(GrindPoint g, BindingList<GrindPoint> list)
        {
            foreach (GrindPoint hotspot in list)
            {
                if (Distance(hotspot, g) <= pointSeparation)
                    return false;
            }
            return true;
        }

        public bool GoodPoint(GrindPoint g,List<GrindPoint> list)
        {
            foreach (GrindPoint hotspot in list)
            {
                if (Distance(hotspot, g) <= pointSeparation)
                    return false;
            }
            return true;
        }

        public int Distance(GrindPoint p1, GrindPoint p2)
        {
            double XDif = Math.Pow((p2.X - p1.X), 2);
            double YDif = Math.Pow((p2.Y - p1.Y), 2);
            int distance = (int)Math.Sqrt(XDif + YDif);

            return distance;
        }

        public static List<string> mobNames(int level)
        {
            List<string> list = new List<string>();
            foreach (GrindPoint g in HotSpots)
            {
                if (!list.Contains(g.MobName) && g.level == level)
                    list.Add(g.MobName);
            }
            return list;
        }

        public static void AdjustLevels()
        {
            int MaxLevel = GetMaxMobLevel + 1;
            foreach (GrindPoint g in HotSpots)
                g.level = MaxLevel;
        }

        private static int GetMaxMobLevel
        {
            get
            {
                return (from g in HotSpots
                        orderby g.level descending
                        select g).FirstOrDefault().level;
            }
        }

        public static void OutputByLevel(int level, StreamWriter o)
        {
            string mobtype = getMobName(level);
            if (mobtype == "None of this Level")
                return;

            o.WriteLine("\t\t<GrindArea>");
            o.WriteLine("\t\t\t<MinLevel>" + currentLevel + "</MinLevel>");
            o.WriteLine("\t\t\t<MaxLevel>" + (level + 1) + "</MaxLevel>");

            //Mob Names
            /*o.WriteLine("\t\t\t<Mobs>");
            foreach (String s in mobNames(level))
            {
                o.WriteLine("\t\t\t\t<Mob>" + s + "</Mob>");
            }
            o.WriteLine("\t\t\t</Mobs>");*/

            //HotSpots
            o.WriteLine("\t\t\t<Hotspots>");
            foreach (GrindPoint g in HotSpots)
            {
                if(g.level == level)
                    o.WriteLine("\t\t\t\t" + g.BuildString());
            }
            o.WriteLine("\t\t\t</Hotspots>");
            o.WriteLine("\t\t</GrindArea>");
            currentLevel++;
        }

        public static string getMobName(int level)
        {
            foreach (GrindPoint g in HotSpots)
            {
                if (g.level == level)
                    return g.MobName;
            }
            return "None of this Level";
        }

        public static void OutputProfile()
        {
            try
            {
                DirectoryInfo dir = new DirectoryInfo(Path.Combine(Directory.GetCurrentDirectory(), string.Format(@"Profiles\")));
                if (!dir.Exists)
                    dir.Create();

                outputPath = Path.Combine(Directory.GetCurrentDirectory(), string.Format(@"Profiles\" + ProfileName + ".xml"));

                StreamWriter o = new StreamWriter(outputPath);
                Logging.Write(outputPath);

                o.WriteLine("<HBProfile creator=\"ProfileBuilder\" version=\"1.0\" >");
                o.WriteLine("\t<Name>" + ProfileName + "</Name>");
                o.WriteLine("");
                setSellStatus();
                o.WriteLine("\t\t" + SellGrey);
                o.WriteLine("\t\t" + SellWhite);
                o.WriteLine("\t\t" + SellGreen);
                o.WriteLine("\t\t" + SellBlue);
                o.WriteLine("\t\t" + SellPurple);
                o.WriteLine("");

                //Merchants
                o.WriteLine("\t\t<Vendors>");
                foreach (GrindPoint g in Merchants)
                {
                    o.WriteLine("\t\t\t" + g.BuildVendorString());
                }
                o.WriteLine("\t\t</Vendors>");
                o.WriteLine("");

                //GrindArea
                AdjustLevels();
                for (int i = startLevel; i < endLevel; i++)
                {
                    OutputByLevel(i, o);
                }
                //o.WriteLine("\t\t\t\t<Grind GrindRef=\"" + HotSpots.ElementAt(0).MobName + "\" While=\"Me.Level &lt; " + endLevel + "\" />");
                o.WriteLine("</HBProfile>");
                o.Close();
            }
            catch
            {
                Logging.Write(outputPath);
            }
        }
    }
}
